C-----------------------------------------------------------------------
      SUBROUTINE FPARSEI(CARG,MARG,KARG)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:  FPARSER       PARSE INTEGERS FROM A CHARACTER STRING
C   PRGMMR: IREDELL          ORG: NP23        DATE:1998-09-03
C
C ABSTRACT: THIS SUBPROGRAM EXTRACTS INTEGERS FROM A FREE-FORMAT
C   CHARACTER STRING.  IT IS USEFUL FOR PARSING COMMAND ARGUMENTS.
C
C PROGRAM HISTORY LOG:
C 1998-09-03  IREDELL  
C
C USAGE:  CALL FPARSEI(CARG,MARG,KARG)
C
C   INPUT ARGUMENT LIST:
C     CARG     - CHARACTER*(*) STRING OF ASCII DIGITS TO PARSE.
C                INTEGERS MAY BE SEPARATED BY A COMMA OR BY BLANKS.
C     MARG     - INTEGER MAXIMUM NUMBER OF INTEGERS TO PARSE.
C
C   OUTPUT ARGUMENT LIST:
C     KARG     - INTEGER (MARG) NUMBERS PARSED.
C                (FROM 0 TO MARG VALUES MAY BE RETURNED.)
C
C REMARKS:
C   TO DETERMINE THE ACTUAL NUMBER OF INTEGERS FOUND IN THE STRING,
C   KARG SHOULD BE SET TO FILL VALUES BEFORE THE CALL TO FPARSEI AND
C   THE NUMBER OF NON-FILL VALUES SHOULD BE COUNTED AFTER THE CALL.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C
C$$$
      CHARACTER*(*) CARG
      INTEGER KARG(MARG)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      READ(CARG,*,IOSTAT=IOS) KARG
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      END
