      SUBROUTINE W3FI01(LW)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .                                       .
C SUBPROGRAM:    W3FI01      DETERMINES MACHINE WORD LENGTH IN BYTES
C   PRGMMR: KEYSER           ORG: W/NMC22    DATE: 06-29-92
C
C ABSTRACT: DETERMINES THE NUMBER OF BYTES IN A FULL WORD FOR THE
C   PARTICULAR MACHINE (IBM OR CRAY).
C
C PROGRAM HISTORY LOG:
C   92-01-10  R. KISTLER (W/NMC23)
C   92-05-22  D. A. KEYSER -- DOCBLOCKED/COMMENTED
C   95-10-31  IREDELL     REMOVED SAVES AND PRINTS
C
C USAGE:    CALL W3FI01(LW)
C   OUTPUT ARGUMENT LIST:      (INCLUDING WORK ARRAYS)
C     LW       - MACHINE WORD LENGTH IN BYTES
C
C REMARKS: SUBPROGRAM CAN BE CALLED FROM A MULTIPROCESSING ENVIRONMENT.
C
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 77
C   MACHINE:  CRAY, WORKSTATIONS
C
C$$$
C
      CHARACTER*8  CTEST1,CTEST2
      CHARACTER*4  CPRINT(2)
C
      INTEGER      ITEST1,ITEST2
C
      EQUIVALENCE  (CTEST1,ITEST1),(CTEST2,ITEST2)
C
      DATA  CTEST1/'12345678'/
C
      ITEST2 = ITEST1
      IF (CTEST1 .EQ. CTEST2) THEN
        LW = 8
      ELSE
        LW = 4
      END IF
      RETURN
      END
